require('myrdb')
local sigTimer
local t0 = 0


function init()
   sigTimer = c8y:addTimer(5*1000, 'sendSignal')
   sigTimer:start()
   return 0
end


local function _sendSignal()
   local rssi = rdbGetInt('wwan.0.radio.information.signal_strength')
   local rscp = rdbGetInt('wwan.0.system_network_status.RSCPs0')
   local valid = rdbGetInt('wwan.0.system_network_status.ECN0_valid')
   if valid == 1 then
      local ecn0 = rdbGetInt('wwan.0.system_network_status.ECN0s0')
      c8y:send(table.concat({'307', c8y.ID, rssi, rscp, ecn0}, ','))
   else
      c8y:send(table.concat({'308', c8y.ID, rssi, rscp}, ','))
   end
end


function sendSignal()
   local val = rdbGetInt('service.cumulocity.plugin.lua__signal.interval')
   local t1 = os.time()
   if val > 0 and os.difftime(t1, t0) > val then
      _sendSignal()
      t0 = t1
   end
end
