require('myrdb')
local timer
local fpath = '/opt/ntcagent/measurementpoll.txt'
local keys = {'service.cumulocity.plugin.ntc6200.gpio.interval',
              'service.cumulocity.plugin.system_resources.interval',
              'service.cumulocity.plugin.lua__signal.interval'}


local function msave(prevs)
   local file = io.open(fpath, 'w')
   if not file then
      srWarning("msave: save setting failed")
      return
   end
   file:write(table.concat(prevs, '\n'))
   file:close()
end


local function mload()
   local prevs = {}
   local file = io.open(fpath)
   if file then
      for line in file:lines() do prevs[#prevs + 1] = line end
      file:close()
      file = io.open(fpath, 'w')
      if file then file:close() end
   end
   for _, line in pairs(prevs) do
      local key, value = string.match(line, '(%S+)%s+(%S+)')
      if key then rdbSet(key, value) end
   end
end


function start(r)
   srInfo("measure poll: freq " .. r:value(4) .. ', duration: ' .. r:value(3))
   local prevs = {}
   for _, key in pairs(keys) do
      prevs[#prevs + 1] = key .. ' ' .. rdbGetStr(key)
      rdbSet(key, r:value(4))
   end
   for i = 1, 3 do
      local key = 'service.cumulocity.gpio.' .. i .. '.notify'
      prevs[#prevs + 1] = key .. ' ' .. rdbGetStr(key)
      rdbSet(key, 'measurement')
   end
   if not timer.isActive then msave(prevs) end
   timer.interval = r:value(3) * 60 * 1000
   timer:start()
   c8y:send('303,' .. r:value(2) .. ',SUCCESSFUL')
end


function stop()
   timer:stop()
   mload()
end


function init()
   mload()
   c8y:addMsgHandler(846, 'start')
   timer = c8y:addTimer(0, 'stop')
   return 0
end
